using System;

namespace Zadatak3
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            int h = int.Parse(s[0]), n = int.Parse(s[1]);
            int[] trenutni = new int[n];
            int[] sledeci = new int[n];
            int[,] matrica = new int[h, n];

            for (int i = 0; i < h; i++)
            {
                s = Console.ReadLine().Split();
                for (int j = 0; j < n; j++)
                {
                    matrica[i, j] =int.Parse(s[j]);
                }
            }

            for (int i = 0; i < n; ++i)
                trenutni[i] = 1;

            int counter = 0,prvi=0,zadnji=0;
            for (int i = 0; i < h; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    counter = 0;

                    if (matrica[i, j] == 1) prvi = j;
                    else prvi = j - 1;

                    while (matrica[i, j] == 0)
                    {
                        counter += trenutni[j];
                        j++;
                        if (j == n)
                            break;
                    }

                    zadnji = j;

                    if (prvi != zadnji) j--;
              

                   
                    if (prvi == zadnji) sledeci[j] += trenutni[j];
                    else if (prvi == -1) sledeci[zadnji] += counter;
                    else if (zadnji == n) sledeci[prvi] += counter;
                    else
                    {
                        if (i % 2 == 1)
                        {
                            if (counter % 2 == 0)
                            {
                                sledeci[prvi] += counter / 2;
                                sledeci[zadnji] += counter / 2;
                            }
                            else
                            {
                                sledeci[prvi] += counter / 2;
                                sledeci[zadnji] += counter / 2 + 1;
                            }
                        }
                        else
                        {
                            if (counter % 2 == 0)
                            {
                                sledeci[prvi] += counter / 2;
                                sledeci[zadnji] += counter / 2;
                            }
                            else
                            {
                                sledeci[prvi] += counter / 2 + 1;
                                sledeci[zadnji] += counter / 2;
                            }
                        }
                    }
                }

                for(int j=0; j<n; ++j)
                {
                    trenutni[j] = sledeci[j];
                    sledeci[j] = 0;
                }
            }

            for (int ispis = 0; ispis < n; ispis++)
            {
                Console.Write(trenutni[ispis] + " ");
            }
        }
    }
}